gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Interfaces.CellLayout

Contents

- Exported types
- Methods
  - addAttribute
  - clear
  - clearAttributes
  - getArea
  - getCells
  - packEnd
  - packStart
  - reorder
  - setCellDataFunc

Description

An interface for packing cells

`GtkCellLayout` is an interface to be implemented by all objects which want to provide a `GtkTreeViewColumn` like API for packing cells, setting attributes and data funcs.

One of the notable features provided by implementations of `GtkCellLayout` are attributes. Attributes let you set the properties in flexible ways. They can just be set to constant values like regular properties. But they can also be mapped to a column of the underlying tree model with `gtk_cell_layout_set_attributes()`, which means that the value of the attribute can change from cell to cell as they are rendered by the cell renderer. Finally, it is possible to specify a function with `cellLayoutSetCellDataFunc` that is called to determine the value of the attribute for each cell that is rendered.

## GtkCellLayouts as GtkBuildable

Implementations of GtkCellLayout which also implement the GtkBuildable interface (`GtkCellView`, `GtkIconView`, `GtkComboBox`, `GtkEntryCompletion`, `GtkTreeViewColumn`) accept `GtkCellRenderer` objects as `<child>` elements in UI definitions. They support a custom `<attributes>` element for their children, which can contain multiple `<attribute>` elements. Each `<attribute>` element has a name attribute which specifies a property of the cell renderer; the content of the element is the attribute value.

This is an example of a UI definition fragment specifying attributes:

### xml code

    <object class="GtkCellView">
      <child>
        <object class="GtkCellRendererText"/>
        <attributes>
          <attribute name="text">0</attribute>
        </attributes>
      </child>
    </object>

Furthermore for implementations of `GtkCellLayout` that use a `GtkCellArea` to lay out cells (all `GtkCellLayout`s in GTK use a `GtkCellArea`) cell properties can also be defined in the format by specifying the custom `<cell-packing>` attribute which can contain multiple `<property>` elements.

Here is a UI definition fragment specifying cell properties:

### xml code

    <object class="GtkTreeViewColumn">
      <child>
        <object class="GtkCellRendererText"/>
        <cell-packing>
          <property name="align">True</property>
          <property name="expand">False</property>
        </cell-packing>
      </child>
    </object>

## Subclassing GtkCellLayout implementations

When subclassing a widget that implements `GtkCellLayout` like `GtkIconView` or `GtkComboBox`, there are some considerations related to the fact that these widgets internally use a `GtkCellArea`. The cell area is exposed as a construct-only property by these widgets. This means that it is possible to e.g. do

### c code

    GtkWIdget *combo =
      g_object_new (GTK_TYPE_COMBO_BOX, "cell-area", my_cell_area, NULL);

to use a custom cell area with a combo box. But construct properties are only initialized after instance `init()` functions have run, which means that using functions which rely on the existence of the cell area in your subclass `init()` function will cause the default cell area to be instantiated. In this case, a provided construct property value will be ignored (with a warning, to alert you to the problem).

### c code

    static void
    my_combo_box_init (MyComboBox *b)
    {
      GtkCellRenderer *cell;

      cell = gtk_cell_renderer_pixbuf_new ();

      // The following call causes the default cell area for combo boxes,
      // a GtkCellAreaBox, to be instantiated
      gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (b), cell, FALSE);
      ...
    }

    GtkWidget *
    my_combo_box_new (GtkCellArea *area)
    {
      // This call is going to cause a warning about area being ignored
      return g_object_new (MY_TYPE_COMBO_BOX, "cell-area", area, NULL);
    }

If supporting alternative cell areas with your derived widget is not important, then this does not have to concern you. If you want to support alternative cell areas, you can do so by moving the problematic calls out of `init()` and into a `constructor()` for your class.

Synopsis

- newtype CellLayout = CellLayout (ManagedPtr CellLayout)
- class (GObject o, IsDescendantOf CellLayout o) => IsCellLayout o
- toCellLayout :: (MonadIO m, IsCellLayout o) => o -> m CellLayout
- cellLayoutAddAttribute :: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) => a -> b -> Text -> Int32 -> m ()
- cellLayoutClear :: (HasCallStack, MonadIO m, IsCellLayout a) => a -> m ()
- cellLayoutClearAttributes :: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) => a -> b -> m ()
- cellLayoutGetArea :: (HasCallStack, MonadIO m, IsCellLayout a) => a -> m (Maybe CellArea)
- cellLayoutGetCells :: (HasCallStack, MonadIO m, IsCellLayout a) => a -> m [CellRenderer]
- cellLayoutPackEnd :: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) => a -> b -> Bool -> m ()
- cellLayoutPackStart :: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) => a -> b -> Bool -> m ()
- cellLayoutReorder :: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) => a -> b -> Int32 -> m ()
- cellLayoutSetCellDataFunc :: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) => a -> b -> Maybe CellLayoutDataFunc -> m ()

# Exported types

newtype CellLayout Source #

Deprecated: (Since version 4.10)List views use widgets to display their contents.See `LayoutManager` for layout manager delegate objects

Memory-managed wrapper type.

Constructors

CellLayout (ManagedPtr CellLayout) | Deprecated: (Since version 4.10)List views use widgets to display their contents.See `LayoutManager` for layout manager delegate objects

#### Instances

Instances details

Eq CellLayout Source # |
Instance details Defined in GI.Gtk.Interfaces.CellLayout Methods (==) :: CellLayout -> CellLayout -> Bool Source # (/=) :: CellLayout -> CellLayout -> Bool Source #
GObject CellLayout Source # |
Instance details Defined in GI.Gtk.Interfaces.CellLayout
ManagedPtrNewtype CellLayout Source # |
Instance details Defined in GI.Gtk.Interfaces.CellLayout Methods toManagedPtr :: CellLayout -> ManagedPtr CellLayout Source #
TypedObject CellLayout Source # |
Instance details Defined in GI.Gtk.Interfaces.CellLayout Methods glibType :: IO GType Source #
HasParentTypes CellLayout Source # |
Instance details Defined in GI.Gtk.Interfaces.CellLayout
IsGValue (Maybe CellLayout) Source # | Convert `CellLayout` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Interfaces.CellLayout Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe CellLayout -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe CellLayout) Source #
type ParentTypes CellLayout Source # |
Instance details Defined in GI.Gtk.Interfaces.CellLayout type ParentTypes CellLayout = '[Object]

class (GObject o, IsDescendantOf CellLayout o) => IsCellLayout o Source #

Type class for types which can be safely cast to `CellLayout`, for instance with `toCellLayout`.

#### Instances

Instances details

(GObject o, IsDescendantOf CellLayout o) => IsCellLayout o Source # |
Instance details Defined in GI.Gtk.Interfaces.CellLayout

toCellLayout :: (MonadIO m, IsCellLayout o) => o -> m CellLayout Source #

Cast to `CellLayout`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

addAttribute, bindProperty, bindPropertyFull, clear, clearAttributes, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, packEnd, packStart, ref, refSink, reorder, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getArea, getCells, getData, getProperty, getQdata.

#### Setters

setCellDataFunc, setData, setDataFull, setProperty.

## addAttribute

cellLayoutAddAttribute Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) |
=> a | `cellLayout`: a `GtkCellLayout`
-> b | `cell`: a `GtkCellRenderer`
-> Text | `attribute`: a property on the renderer
-> Int32 | `column`: the column position on the model to get the attribute from
-> m () |

Deprecated: (Since version 4.10)

Adds an attribute mapping to the list in `cellLayout`.

The `column` is the column of the model to get a value from, and the `attribute` is the property on `cell` to be set from that value. So for example if column 2 of the model contains strings, you could have the “text” attribute of a `GtkCellRendererText` get its values from column 2. In this context "attribute" and "property" are used interchangeably.

## clear

cellLayoutClear Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a) |
=> a | `cellLayout`: a `GtkCellLayout`
-> m () |

Deprecated: (Since version 4.10)

Unsets all the mappings on all renderers on `cellLayout` and removes all renderers from `cellLayout`.

## clearAttributes

cellLayoutClearAttributes Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) |
=> a | `cellLayout`: a `GtkCellLayout`
-> b | `cell`: a `GtkCellRenderer` to clear the attribute mapping on
-> m () |

Deprecated: (Since version 4.10)

Clears all existing attributes previously set with `gtk_cell_layout_set_attributes()`.

## getArea

cellLayoutGetArea Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a) |
=> a | `cellLayout`: a `GtkCellLayout`
-> m (Maybe CellArea) | Returns: the cell area used by `cellLayout`

Deprecated: (Since version 4.10)

Returns the underlying `GtkCellArea` which might be `cellLayout` if called on a `GtkCellArea` or might be `Nothing` if no `GtkCellArea` is used by `cellLayout`.

## getCells

cellLayoutGetCells Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a) |
=> a | `cellLayout`: a `GtkCellLayout`
-> m [CellRenderer] | Returns: a list of cell renderers. The list, but not the renderers has been newly allocated and should be freed with `g_list_free()` when no longer needed.

Deprecated: (Since version 4.10)

Returns the cell renderers which have been added to `cellLayout`.

## packEnd

cellLayoutPackEnd Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) |
=> a | `cellLayout`: a `GtkCellLayout`
-> b | `cell`: a `GtkCellRenderer`
-> Bool | `expand`: `True` if `cell` is to be given extra space allocated to `cellLayout`
-> m () |

Deprecated: (Since version 4.10)

Adds the `cell` to the end of `cellLayout`. If `expand` is `False`, then the `cell` is allocated no more space than it needs. Any unused space is divided evenly between cells for which `expand` is `True`.

Note that reusing the same cell renderer is not supported.

## packStart

cellLayoutPackStart Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) |
=> a | `cellLayout`: a `GtkCellLayout`
-> b | `cell`: a `GtkCellRenderer`
-> Bool | `expand`: `True` if `cell` is to be given extra space allocated to `cellLayout`
-> m () |

Deprecated: (Since version 4.10)

Packs the `cell` into the beginning of `cellLayout`. If `expand` is `False`, then the `cell` is allocated no more space than it needs. Any unused space is divided evenly between cells for which `expand` is `True`.

Note that reusing the same cell renderer is not supported.

## reorder

cellLayoutReorder Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) |
=> a | `cellLayout`: a `GtkCellLayout`
-> b | `cell`: a `GtkCellRenderer` to reorder
-> Int32 | `position`: new position to insert `cell` at
-> m () |

Deprecated: (Since version 4.10)

Re-inserts `cell` at `position`.

Note that `cell` has already to be packed into `cellLayout` for this to function properly.

## setCellDataFunc

cellLayoutSetCellDataFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsCellLayout a, IsCellRenderer b) |
=> a | `cellLayout`: a `GtkCellLayout`
-> b | `cell`: a `GtkCellRenderer`
-> Maybe CellLayoutDataFunc | `func`: the `GtkCellLayout`DataFunc to use
-> m () |

Deprecated: (Since version 4.10)

Sets the `GtkCellLayout`DataFunc to use for `cellLayout`.

This function is used instead of the standard attributes mapping for setting the column value, and should set the value of `cellLayout`’s cell renderer(s) as appropriate.

`func` may be `Nothing` to remove a previously set function.